import { world, system } from '@minecraft/server';

function isLookingAtEntity(player, entityId) {
  const viewDirection = player.getViewDirection();

  const eyePosition = {
    x: player.location.x,
    y: player.location.y,
    z: player.location.z
  };

  const targetPosition = {
    x: eyePosition.x + viewDirection.x * 5,
    y: eyePosition.y + viewDirection.y * 5,
    z: eyePosition.z + viewDirection.z * 5
  };

  const entities = world.getDimension('overworld').getEntities({
    location: targetPosition,
    maxDistance: 6
  });

  for (const entity of entities) {
    if (entity.typeId === entityId) {
      return true;
    }
  }

  return false;
}

function checkPlayers() {
  for (const player of world.getPlayers()) {
    if (isLookingAtEntity(player, 'addon:flash_grenade')) {
      player.addTag("flash");
    } else {
      player.removeTag("flash");
    }
  }
}

system.runInterval(() => {
  checkPlayers();
}, 10);